#ifndef IPARSER_H
#define IPARSER_H
#include <vector>
#include <string_view>
#include "headline.h"
#include "database/pagedao.h"
#include "urlprovider.h"
class IParser
{
public:
   virtual std::string extractCommand(std::string cmdname, std::string content) const = 0 ;
   virtual std::vector<Headline> extractHeadlines(std::string content) const = 0;
	virtual std::string parse(const PageDao &pagedao, UrlProvider &provider, std::string content) const = 0;
	virtual std::vector<std::string> extractCategories(std::string content) const = 0;

	virtual ~IParser() { };
};

#endif // PARSER_H
