#ifndef PARSER_H
#define PARSER_H
#include <boost/regex.hpp>
#include "iparser.h"


class Parser  : public IParser
{
private:
	std::string processLink(const PageDao &pageDao, UrlProvider &urlProvider, boost::smatch &match) const;
public:
	std::string extractCommand(std::string cmdname, std::string content) const ;
	std::vector<Headline> extractHeadlines(std::string content) const override ;
	std::vector<std::string> extractCategories(std::string content) const override;
	std::string parse(const PageDao &pagedao, UrlProvider &provider, std::string content) const override;
	using IParser::IParser;
	~Parser() { };
};

#endif // PARSER_H
